/* [LCD]   [BC2004A]
   1 GND- 9  GND
   2 +5V- 10 VCC  
   3 VLC- LCD contrast adjustment
   4 RS - H/L register selecy signal
   5 R/W- H/L read/write signal
   6 EN - H --> L enable signal
  11 D4 - [4] H/L data bus line
  12 D5 - [5] H/L data bus line
  13 D6 - [6] H/L data bus line
  14 D7 - [7] H/L data bus line
  15 A  - Power supply for LED (+)
  16 K  - Power supply for B/L (GND)
*/

/***************************************************************/
#include <iom128.h>
#include "bits.h"
#include "disp.h"
/*=========================================================================*/
void Lcdinit(void)
{
 Enable_Display=0;			/* CS   LCD */

PORTA=0x0;

PORTA=0x30; PORTA=0x34;PORTA=0x30;		delay_ms(50);

PORTA=0x30; PORTA=0x34;PORTA=0x30;  		delay_ms(50); 

PORTA=0x30; PORTA=0x34;PORTA=0x30;		delay_ms(50); 
                                                                                
PORTA=0x20; PORTA=0x24;PORTA=0x20;		delay_us(200); 
                                        
		     PORTA=0x20; PORTA=0x24;PORTA=0x20;       //set function N=1,F=0
                     PORTA=0x80; PORTA=0x84;PORTA=0x80;  delay_us(200);	// =28

           PORTA=0x0; PORTA=0x04;PORTA=0x0;           //display off
           PORTA=0x80; PORTA=0x84; PORTA=0x80;  delay_us(200);

           PORTA=0x0; PORTA=0x04; PORTA=0x0;             //display clear
           PORTA=0x10; PORTA=0x14; PORTA=0x10;  delay_us(200);

                     PORTA=0x04;                //entry mode set
                     PORTA=0x60; PORTA=0x64;PORTA=0x60; delay_us(200);// I/D=1,S=1
                    
                     PORTA=0x04;                //display on
                     PORTA=0xC0; PORTA=0xC4;PORTA=0xC0; delay_us(200);
                                                                                
                     PORTA=0x04;                //cursor home DDRAM=0
                     PORTA=0x01; PORTA=0x05;PORTA=0x01;PORTA=0x0; delay_us(200);
                                        
                     lcd_count=0;
	Enable_Display=1;			/* CS   LCD */
}
/***************************************************************|
|					|
|***************************************************************/
void Lcdwrite(void)
{
		PORTA=0;				// cleen !!!
	Enable_Display=0;			/* CS   LCD */
   Cursor_Home();
	Enable_Display=0;			/* CS   LCD */
		PORTA=0;
			DISPLAY_E=1;
		PORTA=0x20;			/* display home */
			DISPLAY_E=1; DISPLAY_E=0;
				delay_us(200);     

Wr_Str_Lcd(0, 20);		// 1 
Wr_Str_Lcd(40, 60);		// 3 
Wr_Str_Lcd(20, 40);		// 2 
Wr_Str_Lcd(60, 80);		// 4 

	Enable_Display=1;			/* CS   LCD */
}

/***************************************************************|
|	                              				|
|***************************************************************|
|--------------------------------------------------------------*/
void Wr_Str_Lcd(unsigned char lcd_start, unsigned char lcd_end)
{
    for(lcd_count=lcd_start;lcd_count<lcd_end;lcd_count++)
       {
	dat= DISPL.LCD_RAM[lcd_count];
	com_dat = 1;				// RS = data

		WR_Display_Byte(dat);

       }     
} 
//-------------------------------------------------------------------  
void WR_Display_Byte(unsigned char byte)
{   unsigned char dat_high,dat_low;

		PORTA=0;				// cleen
	Enable_Display=0;			/* CS   LCD */

	dat_high=(byte & 0xF0) | com_dat;
	dat_low=((byte & 0x0F) << 4) | com_dat;	// com_dat =1 -> RS=1 - data
						//  =0 -> RS=0 - command,addres

	PORTA=dat_high; PORTA=dat_high;	DISPLAY_E=1;DISPLAY_E=0;
		PORTA=PORTA & 0x0F;			// cleen
	PORTA=dat_low; PORTA=dat_low;	DISPLAY_E=1;DISPLAY_E=0;    

							 delay_us(175);

	Enable_Display=1;			/* CS   LCD */

}
/***************************************************************/
void WR_Display_One_Byte(unsigned char byte)
{   unsigned char dat_high,dat_low;

		PORTA=0;
	Enable_Display=0;			/* CS   LCD */

	dat_high=(byte & 0xF0) | com_dat;
	dat_low=((byte & 0x0F) << 4) | com_dat;	// com_dat =1 -> RS=1 - data
						//  =0 -> RS=0 - command,addres

	PORTA=dat_high; PORTA=dat_high;	DISPLAY_E=1;DISPLAY_E=0;
		PORTA=PORTA & 0x0F;			// cleen
	PORTA=dat_low; PORTA=dat_low;	DISPLAY_E=1;DISPLAY_E=0;

     delay_us(175);
	Enable_Display=1;			/* CS   LCD */

}
/***************************************************************/
void Write_Addr_Display(unsigned char addr)
{
	com_dat = 0;				// RS = addr

		WR_Display_One_Byte(addr | 0x80);	// DB7=1
	delay_us(130);
}
/*---------------------------------*/
void Display_Clear(void)
{	dat= 0x1;
	com_dat = 0;				// RS = command
	WR_Display_One_Byte(dat);
	delay_ms(5);
}
/*---------------------------------*/
void Cursor_Home(void)
{	dat= 0x2;
	com_dat = 0;
	WR_Display_One_Byte(dat);
	delay_ms(5);
}
/*---------------------------------*/
void Cursor_Off(void)
{	dat= 0xC;
	com_dat = 0;
	WR_Display_One_Byte(dat);
	delay_us(130);
}
/*---------------------------------*/
void Cursor_Blink(void)
{	dat= 0xF;
	com_dat = 0;
	WR_Display_One_Byte(dat);
	delay_us(130);
}
/*---------------------------------*/
void Cursor_Shift_Left(void)
{	dat= 0x10;
	com_dat = 0;
	WR_Display_One_Byte(dat);
	delay_us(130);
}
/*---------------------------------*/
